// -------------------------------------------------------------
// paraboloid.fx
// 
// Copyright (c) 2004 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------


// -------------------------------------------------------------
// Transformation for rendering a paraboloid map (}bv_VF[_vO)
// -------------------------------------------------------------
float4 paraboloid( float4 vPosition, float4x4 mWV )
{   
	float4 Out = (float4)0;
	float3 pos;
	float l;
	
	float z_min = 0.1;			// Near plane
	float z_max = 100.0;		// Far plane
	
	// Position in the view space(ʒuW)
	pos = mul( vPosition, mWV ).xyz;
	
	l = length( pos );
	
	Out.xy = pos.xy * l * (l-pos.z) / dot( pos.xy, pos.xy );
	
	if( 0 <= pos.z )
	{
		Out.z = (l-z_min)*z_max/(z_max-z_min);
		Out.w = l;
	} else {
		// Fly vertexs in the back to an infinite distant place.
		// (wʂɂ钸_͖ɔ΂)
		Out.z = 0;
		Out.w = -0.00001;
	}
	
    return Out;
}


